#!/usr/bin/env node
'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var argv = _yargs2.default.usage('Usage: $0 [schema.json . --ignore-dirs=__tests__,__mocks__,node_modules --subdir=__relay__ --extension={jsx,js} --remove-old]').options({
    'ignore-dirs': {
        type: 'string',
        default: '__tests__,__mocks__,node_modules',
        describe: 'Any directories to ignore'
    },
    'subdir': {
        type: 'string',
        default: '__relay__',
        describe: 'The subdirectory in which to place the generated flow types'
    },
    'remove-old': {
        type: 'boolean',
        default: false,
        describe: 'Remove __relay__ directories before generating new types - BE CAREFUL IF USING IN CONJUNCTION WITH --subdir'
    },
    'extension': {
        type: 'string',
        default: '{jsx,js}',
        describe: 'File extensions to check'
    }
}).strict().help().argv;

var _argv$_ = _slicedToArray(argv._, 2),
    _argv$_$ = _argv$_[0],
    schemaPath = _argv$_$ === undefined ? 'schema.json' : _argv$_$,
    _argv$_$2 = _argv$_[1],
    cwd = _argv$_$2 === undefined ? '.' : _argv$_$2;

if (argv.removeOld) {
    var dirs = _glob2.default.sync('./**/' + argv.subdir, {
        cwd: cwd,
        realpath: true,
        ignore: argv.ignoreDirs.split(',').map(function (dirname) {
            return './**/' + dirname + '/**';
        })
    });
    dirs.forEach(function (dirpath) {
        _fs2.default.readdirSync(dirpath).forEach(function (filename) {
            if (!filename.match(/\.js$/) || !filename.indexOf(argv.subdir)) {
                throw Error('Unexpected file found');
            }
            _fs2.default.unlinkSync(_path2.default.join(dirpath, filename));
        });
        _fs2.default.rmdirSync(dirpath);
    });
}

var files = _glob2.default.sync('./**/*.' + argv.extension, {
    cwd: cwd,
    realpath: true,
    ignore: argv.ignoreDirs.split(',').map(function (dirname) {
        return './**/' + dirname + '/**/*';
    })
});

(0, _index2.default)(files, _path2.default.resolve(schemaPath), argv.subdir);