'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (files, schemaPath) {
    var subdir = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '__relay__';

    var schema = (0, _buildClientSchema.buildClientSchema)(require(schemaPath));

    files.forEach(function (filename) {
        var outputDir = _path2.default.join(_path2.default.dirname(filename), subdir);
        var outputFilename = _path2.default.join(outputDir, _path2.default.basename(filename));

        _fs2.default.readFile(filename, { encoding: 'utf8' }, function (err, contents) {
            if (err) {
                console.error(err);
            } else {
                var flowtypes = (0, _parse2.default)(contents, schema);
                if (Object.keys(flowtypes).length) {
                    // Sync to avoid race conditions
                    if (!_fs2.default.existsSync(outputDir)) {
                        _fs2.default.mkdirSync(outputDir);
                    }

                    var outputFileContents = (0, _generate2.default)(flowtypes, _path2.default.basename(filename));
                    _fs2.default.writeFile(outputFilename, outputFileContents, { encoding: 'utf8' }, function (err) {
                        if (err) {
                            process.stderr.write(JSON.stringify(err));
                        }
                    });
                }
            }
        });
    });
};

var _parse = require('./parse');

var _parse2 = _interopRequireDefault(_parse);

var _generate = require('./generate');

var _generate2 = _interopRequireDefault(_generate);

var _buildClientSchema = require('graphql/utilities/buildClientSchema');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

;